#!/bin/sh
set -e
-local TESTDIR=$(readlink -f $(dirname $0))
+TESTDIR=$(readlink -f $(dirname $0))
. $TESTDIR/framework
setupenvironment
configarchitecture "i386"
buildaptarchive
+touch aptarchive/Packages
setupflataptarchive
testaptgetupdate() {
+ rm -rf rootdir/var/lib/apt
aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
- sed -i -e '/^Fetched / d' -e 's#\[[0-9]*[kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
+ sed -i -e '/^Fetched / d' -e '/Ign / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
GIVEN="$1"
shift
msgtest "Test for correctness of" "apt-get update with $*"
rm testaptgetupdate.diff
}
-touch aptarchive/en.bz2
-
-testaptgetupdate "Ign file: Release.gpg
-Ign file:$(readlink -f aptarchive)/ Translation-en
-Get:1 file: Release []
-Reading package lists..." "empty file en.bz2 over file"
+createemptyarchive() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages
+ echo -n "" | $COMPRESSOR > aptarchive/${1}.$COMPRESS
+ generatereleasefiles
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
+createemptyfile() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages aptarchive/${1}.$COMPRESS
+ generatereleasefiles
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-testaptgetupdate "Ign file: Release.gpg
-Get:1 file: Release []
-Reading package lists..." "empty archive en.bz2 over file"
+setupcompressor() {
+ COMPRESSOR="$1"
+ case $COMPRESSOR in
+ gzip) COMPRESS="gz";;
+ bzip2) COMPRESS="bz2";;
+ lzma) COMPRESS="lzma";;
+ xz) COMPRESS="xz";;
+ esac
+ echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
+Dir::Bin::uncompressed \"/does/not/exist\";
+Dir::Bin::gzip \"/does/not/exist\";
+Dir::Bin::bzip2 \"/does/not/exist\";
+Dir::Bin::lzma \"/does/not/exist\";
+Dir::Bin::xz \"/does/not/exist\";" > rootdir/etc/apt/apt.conf.d/00compressor
+ if [ -e "/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ else
+ msgtest "Test for availability of compressor" "${COMPRESSOR}"
+ msgfail
+ exit 1
+ fi
+}
-rm aptarchive/en.bz2
+testoverfile() {
+ setupcompressor "$1"
-# do the same again with http instead of file
-changetowebserver
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 file: InRelease []
+Reading package lists..." "empty file en.$COMPRESS over file"
-touch aptarchive/en.bz2
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 file: InRelease []
+Reading package lists..." "empty archive en.$COMPRESS over file"
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en
-Get:2 http://localhost Release []
-Ign http://localhost/ Translation-en
-Get:3 http://localhost Packages []
-Reading package lists..." "empty file en.bz2 over http"
+ createemptyarchive 'Packages'
+ # FIXME: Why omits the file transport the Packages Get line?
+ #Get:3 file: Packages []
+ testaptgetupdate "Get:1 file: InRelease []
+Reading package lists..." "empty archive Packages.$COMPRESS over file"
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
+ createemptyfile 'Packages'
+ testaptgetupdate "Get:1 file: InRelease []
+Err file: Packages
+ Empty files can't be valid archives
+W: Failed to fetch ${COMPRESSOR}:$(readlink -f aptarchive/Packages.$COMPRESS) Empty files can't be valid archives
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en []
-Get:2 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:3 http://localhost Packages []
-Reading package lists..." "empty archive en.bz2 over http"
+E: Some index files failed to download. They have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over file"
+}
-rm aptarchive/en.bz2
+testoverhttp() {
+ setupcompressor "$1"
-rm aptarchive/Packages
-touch aptarchive/Packages
-buildaptarchivefromfiles
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 http://localhost InRelease []
+Get:2 http://localhost Packages []
+Get:3 http://localhost Translation-en
+Reading package lists..." "empty file en.$COMPRESS over http"
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 http://localhost InRelease []
Get:2 http://localhost Packages []
-Reading package lists..." "empty archive Packages over http"
+Get:3 http://localhost Translation-en []
+Reading package lists..." "empty archive en.$COMPRESS over http"
-find aptarchive/ -name 'Packages*' -type f -delete
-touch aptarchive/Packages.bz2
-aptftparchive release aptarchive/ > aptarchive/Release
+ createemptyarchive 'Packages'
+ testaptgetupdate "Get:1 http://localhost InRelease []
+Get:2 http://localhost Packages []
+Reading package lists..." "empty archive Packages.$COMPRESS over http"
-#FIXME: we should response with a good error message instead
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
+ createemptyfile 'Packages'
+ #FIXME: we should response with a good error message instead
+ testaptgetupdate "Get:1 http://localhost InRelease []
Get:2 http://localhost Packages
Err http://localhost Packages
- Undetermined Error
-W: Failed to fetch http://localhost:8080/Packages.bz2 Undetermined Error
+ Empty files can't be valid archives
+W: Failed to fetch ${COMPRESSOR}:$(readlink -f rootdir/var/lib/apt/lists/partial/localhost:8080_Packages) Empty files can't be valid archives
+
+E: Some index files failed to download. They have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
+}
+
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma' 'xz'; do testoverfile $COMPRESSOR; done
+
+# do the same again with http instead of file
+changetowebserver
-E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages over http"
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma' 'xz'; do testoverhttp $COMPRESSOR; done